--- C:/DOCUME~1/JCHARR~1/LOCALS~1/Temp/French.keymap-revBASE.svn000.tmp.keymap	sam. juil. 10 19:51:14 2010
+++ Q:/svn/keymap/French.keymap	sam. juil. 10 19:47:27 2010
@@ -1,4 +1,4 @@
-#!/bin/keymap -l
+#!/bin/keymap -s
 #
 #	Raw key numbering for 101 keyboard...
 #                                                                                        [sys]       [brk]
@@ -98,15 +98,15 @@
 Key 0x24 = '*'      '*'      '*'      '*'      '*'      '*'      '*'      '*'      '*'      
 Key 0x25 = '-'      '-'      '-'      '-'      '-'      '-'      '-'      '-'      '-'      
 Key 0x26 = 0x09     0x09     0x09     0x09     0x09     0x09     0x09     0x09     0x09     
-Key 0x27 = 'a'      'A'      0x01     ' '      ''       'A'      'a'      ' '      ''       
+Key 0x27 = 'a'      'A'      0x01     0xc3a6   0xc386   'A'      'a'      ' '      ''       
 Key 0x28 = 'z'      'Z'      0x1a     ' '      ''       'Z'      'z'      ' '      ''       
 Key 0x29 = 'e'      'E'      0x05     0xe282ac ''       'E'      'e'      0xe282ac ''       
-Key 0x2a = 'r'      'R'      0x12     ' '      ''       'R'      'r'      ' '      ''       
+Key 0x2a = 'r'      'R'      0x12     0xc2ae   ''       'R'      'r'      ' '      ''       
 Key 0x2b = 't'      'T'      0x14     ' '      ''       'T'      't'      ' '      ''       
 Key 0x2c = 'y'      'Y'      0x19     ' '      ''       'Y'      'y'      ' '      ''       
 Key 0x2d = 'u'      'U'      0x15     ' '      ''       'U'      'u'      ' '      ''       
 Key 0x2e = 'i'      'I'      0x09     ' '      ''       'I'      'i'      ' '      ''       
-Key 0x2f = 'o'      'O'      0x0f     ' '      ''       'O'      'o'      ' '      ''       
+Key 0x2f = 'o'      'O'      0x0f     0xc593   0xc592   'O'      'o'      ' '      ''       
 Key 0x30 = 'p'      'P'      0x10     ' '      ''       'P'      'p'      ' '      ''       
 Key 0x31 = '^'      0xc2a8   0x1b     ' '      ''       0xc2a8   '^'      ' '      ''       
 Key 0x32 = '$'      0xc2a3   0x1d     0xc2a4   ''       0xc2a3   '$'      0xc2a4   ''       
@@ -137,12 +137,12 @@
 Key 0x4b = ''       ''       ''       ''       ''       ''       ''       ''       ''       
 Key 0x4c = 'w'      'W'      0x17     ' '      ''       'W'      'w'      ' '      ''       
 Key 0x4d = 'x'      'X'      0x18     ' '      ''       'X'      'x'      ' '      ''       
-Key 0x4e = 'c'      'C'      0x03     ' '      ''       'C'      'c'      ' '      ''       
+Key 0x4e = 'c'      'C'      0x03     0xc2a9   ''       'C'      'c'      ' '      ''       
 Key 0x4f = 'v'      'V'      0x16     ' '      ''       'V'      'v'      ' '      ''       
 Key 0x50 = 'b'      'B'      0x02     ' '      ''       'B'      'b'      ' '      ''       
 Key 0x51 = 'n'      'N'      0x0e     ' '      ''       'N'      'n'      ' '      ''       
 Key 0x52 = ','      '?'      ''       ' '      ''       '?'      ','      ' '      ''       
-Key 0x53 = ';'      '.'      ''       ' '      ''       '.'      ';'      ' '      ''       
+Key 0x53 = ';'      '.'      ''       ' '      0xe280a6 '.'      ';'      ' '      ''       
 Key 0x54 = ':'      '/'      ''       ' '      ''       '/'      ':'      ' '      ''       
 Key 0x55 = '!'      0xc2a7   ''       ' '      ''       0xc2a7   '!'      ' '      ''       
 Key 0x56 = ''       ''       ''       ''       ''       ''       ''       ''       ''       
@@ -164,7 +164,7 @@
 Key 0x66 = ''       ''       ''       ''       ''       ''       ''       ''       ''       
 Key 0x67 = ''       ''       ''       ''       ''       ''       ''       ''       ''       
 Key 0x68 = ''       ''       ''       ''       ''       ''       ''       ''       ''       
-Key 0x69 = '<'      '>'      0x1c     ' '      ''       '<'      '>'      ' '      ''       
+Key 0x69 = '<'      '>'      0x1c     0xc2ab   0xc2bb   '<'      '>'      ' '      ''       
 Key 0x6a = ''       ''       ''       ''       ''       ''       ''       ''       ''       
 Key 0x6b = ''       ''       ''       ''       ''       ''       ''       ''       ''       
 Key 0x6c = ''       ''       ''       ''       ''       ''       ''       ''       ''       