Index: /HiQ-Data/source/haiku/trunk/src/apps/codycam/CodyCam.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/codycam/CodyCam.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/codycam/CodyCam.cpp	(working copy)
@@ -240,7 +240,7 @@
 		}
 
 		case msg_about:
-			(new BAlert(B_TRANSLATE("About CodyCam"), B_TRANSLATE("CodyCam\n\n"
+			(new BAlert("About CodyCam", B_TRANSLATE("CodyCam\n\n"
 				"The Original BeOS webcam"), B_TRANSLATE("Close")))->Go();
 			break;
 
Index: /HiQ-Data/source/haiku/trunk/src/apps/diskprobe/ProbeView.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/diskprobe/ProbeView.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/diskprobe/ProbeView.cpp	(working copy)
@@ -1103,7 +1103,7 @@
 		if (system_time() > startTime + 8000000LL) {
 			// If the user had to wait more than 8 seconds for the result,
 			// we are trying to please him with a requester...
-			(new BAlert(B_TRANSLATE("DiskProbe request"),
+			(new BAlert("DiskProbe request",
 				B_TRANSLATE("Could not find search string."), 
 				B_TRANSLATE("OK"), NULL, NULL, B_WIDTH_AS_USUAL, 
 				B_WARNING_ALERT))->Go(NULL);
@@ -1865,7 +1865,7 @@
 		"All changes will be lost when you quit."),
 		strerror(status));
 
-	(new BAlert(B_TRANSLATE("DiskProbe request"),
+	(new BAlert("DiskProbe request",
 		buffer, B_TRANSLATE("OK"), NULL, NULL,
 		B_WIDTH_AS_USUAL, B_WARNING_ALERT))->Go(NULL);
 
@@ -1881,7 +1881,7 @@
 	if (!fEditor.IsModified())
 		return true;
 
-	int32 chosen = (new BAlert(B_TRANSLATE("DiskProbe request"),
+	int32 chosen = (new BAlert("DiskProbe request",
 		B_TRANSLATE("Save changes before closing?"), B_TRANSLATE("Don't save"), B_TRANSLATE("Cancel"), 
 		B_TRANSLATE("Save"),	B_WIDTH_AS_USUAL, B_WARNING_ALERT))->Go();
 
Index: /HiQ-Data/source/haiku/trunk/src/apps/diskprobe/DiskProbe.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/diskprobe/DiskProbe.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/diskprobe/DiskProbe.cpp	(working copy)
@@ -367,7 +367,7 @@
 				"error message is shown."),
 				ref.name, strerror(status));
 
-			(new BAlert(B_TRANSLATE("DiskProbe request"),
+			(new BAlert("DiskProbe request",
 				buffer, B_TRANSLATE("OK"), NULL, NULL,
 				B_WIDTH_AS_USUAL, B_STOP_ALERT))->Go();
 		}
Index: /HiQ-Data/source/haiku/trunk/src/apps/diskprobe/AttributeWindow.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/diskprobe/AttributeWindow.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/diskprobe/AttributeWindow.cpp	(working copy)
@@ -283,7 +283,7 @@
 				"the file \"%s\"?\n\nYou cannot undo this action."),
 				fAttribute, Ref().name);
 
-			int32 chosen = (new BAlert(B_TRANSLATE("DiskProbe request"),
+			int32 chosen = (new BAlert("DiskProbe request",
 				buffer, B_TRANSLATE("Cancel"), B_TRANSLATE("Remove"), NULL,
 				B_WIDTH_AS_USUAL, B_WARNING_ALERT))->Go();
 			if (chosen == 1) {
Index: /HiQ-Data/source/haiku/trunk/src/apps/terminal/TermWindow.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/terminal/TermWindow.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/terminal/TermWindow.cpp	(working copy)
@@ -249,7 +249,7 @@
 	if (isBusy) {
 		const char* alertMessage = B_TRANSLATE("A process is still running.\n"
 			"If you close the Terminal the process will be killed.");
-		BAlert* alert = new BAlert(B_TRANSLATE("Really quit?"),
+		BAlert* alert = new BAlert("Really quit?",
 			alertMessage, B_TRANSLATE("OK"), B_TRANSLATE("Cancel"), NULL,
 			B_WIDTH_AS_USUAL, B_WARNING_ALERT);
 		int32 result = alert->Go();
@@ -492,7 +492,7 @@
 				const char* errorMsg = !fFindSelection
 					? B_TRANSLATE("No search string was entered.")
 					: B_TRANSLATE("Nothing is selected.");
-				BAlert* alert = new BAlert(B_TRANSLATE("Find failed"),
+				BAlert* alert = new BAlert("Find failed",
 					errorMsg, B_TRANSLATE("OK"), NULL, NULL,
 					B_WIDTH_AS_USUAL, B_WARNING_ALERT);
 
@@ -508,7 +508,7 @@
 			findresult = _ActiveTermView()->Find(fFindString, fForwardSearch, fMatchCase, fMatchWord);
 
 			if (!findresult) {
-				BAlert* alert = new BAlert(B_TRANSLATE("Find failed"),
+				BAlert* alert = new BAlert("Find failed",
 					B_TRANSLATE("Text not found."),
 					B_TRANSLATE("OK"), NULL, NULL,
 					B_WIDTH_AS_USUAL, B_WARNING_ALERT);
@@ -531,7 +531,7 @@
 				(message->what == MENU_FIND_NEXT) == fForwardSearch,
 				fMatchCase, fMatchWord);
 			if (!findresult) {
-				BAlert* alert = new BAlert(B_TRANSLATE("Find failed"),
+				BAlert* alert = new BAlert("Find failed",
 					B_TRANSLATE("Not found."), B_TRANSLATE("OK"),
 					NULL, NULL, B_WIDTH_AS_USUAL, B_WARNING_ALERT);
 				alert->SetShortcut(0, B_ESCAPE);
@@ -764,7 +764,7 @@
 TermWindow::_DoPrint()
 {
 	if (!fPrintSettings || (_DoPageSetup() != B_OK)) {
-		(new BAlert(B_TRANSLATE("Cancel"), B_TRANSLATE("Print cancelled."),
+		(new BAlert("Cancel", B_TRANSLATE("Print cancelled."),
 			B_TRANSLATE("OK")))->Go();
 		return;
 	}
Index: /HiQ-Data/source/haiku/trunk/src/apps/soundrecorder/RecorderWindow.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/soundrecorder/RecorderWindow.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/soundrecorder/RecorderWindow.cpp	(working copy)
@@ -1325,12 +1325,12 @@
 	}
 
 	if (countBad > 0 && countGood == 0)
-		(new BAlert(B_TRANSLATE("Nothing to play"), B_TRANSLATE("None of the "
+		(new BAlert("Nothing to play", B_TRANSLATE("None of the "
 			"files appear to be audio files"), B_TRANSLATE("OK"), NULL, NULL, 
 			B_WIDTH_AS_USUAL, B_STOP_ALERT))->Go();
 	else if (countGood > 0) {
 		if (countBad > 0)
-			(new BAlert(B_TRANSLATE("Invalid audio files"), B_TRANSLATE("Some "
+			(new BAlert("Invalid audio files", B_TRANSLATE("Some "
 				"of the files don't appear to be audio files"), 
 				B_TRANSLATE("OK"), NULL, NULL, B_WIDTH_AS_USUAL, 
 				B_WARNING_ALERT))->Go();
Index: /HiQ-Data/source/haiku/trunk/src/apps/showimage/ShowImageWindow.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/showimage/ShowImageWindow.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/showimage/ShowImageWindow.cpp	(working copy)
@@ -1044,7 +1044,7 @@
 			name.String());
 	}
 
-	BAlert* pAlert = new BAlert(B_TRANSLATE("Close document"), prompt.String(),
+	BAlert* pAlert = new BAlert("Close document", prompt.String(),
 		B_TRANSLATE("Cancel"), B_TRANSLATE("Close"));
 	if (pAlert->Go() == 0) {
 		// Cancel
Index: /HiQ-Data/source/haiku/trunk/src/apps/pulse/DeskbarPulseView.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/pulse/DeskbarPulseView.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/pulse/DeskbarPulseView.cpp	(working copy)
@@ -124,7 +124,7 @@
 			prefswindow->Show();
 			break;
 		case PV_ABOUT: {
-			BAlert *alert = new BAlert(B_TRANSLATE("Info"), 
+			BAlert *alert = new BAlert("Info", 
 				B_TRANSLATE("Pulse\n\nBy David Ramsey and Arve Hjønnevåg\n"
 				"Revised by Daniel Switkin"), B_TRANSLATE("OK"));
 			alert->Go(NULL);
@@ -177,7 +177,7 @@
 	if (err != B_OK) {
 		char temp[255];
 		sprintf(temp, B_TRANSLATE("Remove(): %s"), strerror(err));
-		BAlert *alert = new BAlert(B_TRANSLATE("Info"), temp, 
+		BAlert *alert = new BAlert("Info", temp, 
 			B_TRANSLATE("OK"));
 		alert->Go(NULL);
 	}
Index: /HiQ-Data/source/haiku/trunk/src/apps/pulse/PulseWindow.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/pulse/PulseWindow.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/pulse/PulseWindow.cpp	(working copy)
@@ -103,7 +103,7 @@
 			break;
 		}
 		case PV_ABOUT: {
-			BAlert *alert = new BAlert(B_TRANSLATE("Info"), 
+			BAlert *alert = new BAlert("Info", 
 				B_TRANSLATE("Pulse\n\nBy David Ramsey and Arve Hjønnevåg\n"
 				"Revised by Daniel Switkin"), B_TRANSLATE("OK"));
 			// Use the asynchronous version so we don't block the window's thread
Index: /HiQ-Data/source/haiku/trunk/src/apps/pulse/CPUButton.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/pulse/CPUButton.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/pulse/CPUButton.cpp	(working copy)
@@ -276,7 +276,7 @@
 {
 	switch (message->what) {
 		case B_ABOUT_REQUESTED: {
-			BAlert *alert = new BAlert(B_TRANSLATE("Info"), 
+			BAlert *alert = new BAlert("Info", 
 				B_TRANSLATE("Pulse\n\nBy David Ramsey and Arve Hjønnevåg\n"
 				"Revised by Daniel Switkin"), B_TRANSLATE("OK"));
 			// Use the asynchronous version so we don't block the window's thread
Index: /HiQ-Data/source/haiku/trunk/src/apps/installer/InstallerWindow.cpp
===================================================================
--- /HiQ-Data/source/haiku/trunk/src/apps/installer/InstallerWindow.cpp	(revision 37795)
+++ /HiQ-Data/source/haiku/trunk/src/apps/installer/InstallerWindow.cpp	(working copy)
@@ -565,17 +565,17 @@
 InstallerWindow::QuitRequested()
 {
 	if (fDriveSetupLaunched && fBootmanLaunched) {
-		(new BAlert(B_TRANSLATE("Quit Boot Manager and DriveSetup"),
+		(new BAlert("Quit Boot Manager and DriveSetup",
 			B_TRANSLATE("Please close the Boot Manager and DriveSetup windows "
 			"before closing the Installer window."), B_TRANSLATE("OK")))->Go();
 		return false;
 	} else if (fDriveSetupLaunched) {
-		(new BAlert(B_TRANSLATE("Quit DriveSetup"),
+		(new BAlert("Quit DriveSetup",
 			B_TRANSLATE("Please close the DriveSetup window before closing "
 			"the Installer window."), B_TRANSLATE("OK")))->Go();
 		return false;
 	} else if (fBootmanLaunched) {
-		(new BAlert(B_TRANSLATE("Quit Boot Manager"),
+		(new BAlert("Quit Boot Manager",
 			B_TRANSLATE("Please close the Boot Manager window before closing "
 			"the Installer window."), B_TRANSLATE("OK")))->Go();
 		return false;