Index: ../src/add-ons/kernel/bus_managers/scsi/device_scan.cpp
===================================================================
--- ../src/add-ons/kernel/bus_managers/scsi/device_scan.cpp	(revision 40842)
+++ ../src/add-ons/kernel/bus_managers/scsi/device_scan.cpp	(working copy)
@@ -117,7 +117,7 @@
 			// bad luck
 			if (std::min((int)cmd->allocation_length,
 						new_inquiry_data->additional_length + 4)
-					>= (int)offsetof(scsi_res_inquiry, version_descriptor[9])) {
+					>= (int)offsetof(scsi_res_inquiry, _res74)) {
 				int i, previousStandard = -1;
 
 				for (i = 0; i < 8; ++i) {
Index: ../src/add-ons/decorators/BeDecorator/BeDecorator.cpp
===================================================================
--- ../src/add-ons/decorators/BeDecorator/BeDecorator.cpp	(revision 40842)
+++ ../src/add-ons/decorators/BeDecorator/BeDecorator.cpp	(working copy)
@@ -267,7 +267,7 @@
 
 	bool hasTab = false;
 
-	switch (Look()) {
+	switch ((int)Look()) {
 		case B_MODAL_WINDOW_LOOK:
 			fBorderWidth = 5;
 			break;
@@ -429,7 +429,7 @@
 
 	// Draw the border frame
 	BRect r = BRect(fTopBorder.LeftTop(), fBottomBorder.RightBottom());
-	switch (fLook) {
+	switch ((int)fLook) {
 		case B_TITLED_WINDOW_LOOK:
 		case B_DOCUMENT_WINDOW_LOOK:
 		case B_MODAL_WINDOW_LOOK:
@@ -540,7 +540,7 @@
 	if (!(fFlags & B_NOT_RESIZABLE)) {
 		r = fResizeRect;
 
-		switch (fLook) {
+		switch ((int)fLook) {
 			case B_DOCUMENT_WINDOW_LOOK:
 			{
 				if (!invalid.Intersects(r))
@@ -884,7 +884,7 @@
 	// Handle invalidation of resize rect
 	if (dirty && !(fFlags & B_NOT_RESIZABLE)) {
 		BRect realResizeRect;
-		switch (fLook) {
+		switch ((int)fLook) {
 			case B_DOCUMENT_WINDOW_LOOK:
 				realResizeRect = fResizeRect;
 				// Resize rect at old location
Index: ../src/add-ons/decorators/SATDecorator/SATDecorator.cpp
===================================================================
--- ../src/add-ons/decorators/SATDecorator/SATDecorator.cpp	(revision 40842)
+++ ../src/add-ons/decorators/SATDecorator/SATDecorator.cpp	(working copy)
@@ -126,7 +126,7 @@
 
 	bool hasTab = false;
 
-	switch (Look()) {
+	switch ((int)Look()) {
 		case B_MODAL_WINDOW_LOOK:
 			fBorderWidth = 5;
 			break;
Index: ../src/servers/app/DefaultDecorator.cpp
===================================================================
--- ../src/servers/app/DefaultDecorator.cpp	(revision 40842)
+++ ../src/servers/app/DefaultDecorator.cpp	(working copy)
@@ -350,7 +350,7 @@
 
 	bool hasTab = false;
 
-	switch (Look()) {
+	switch ((int)Look()) {
 		case B_MODAL_WINDOW_LOOK:
 			fBorderWidth = 5;
 			break;
@@ -511,7 +511,7 @@
 
 	// Draw the border frame
 	BRect r = BRect(fTopBorder.LeftTop(), fBottomBorder.RightBottom());
-	switch (fLook) {
+	switch ((int)fLook) {
 		case B_TITLED_WINDOW_LOOK:
 		case B_DOCUMENT_WINDOW_LOOK:
 		case B_MODAL_WINDOW_LOOK:
@@ -655,7 +655,7 @@
 		ComponentColors colors;
 		_GetComponentColors(COMPONENT_RESIZE_CORNER, colors);
 
-		switch (fLook) {
+		switch ((int)fLook) {
 			case B_DOCUMENT_WINDOW_LOOK:
 			{
 				if (!invalid.Intersects(r))
@@ -989,7 +989,7 @@
 	// Handle invalidation of resize rect
 	if (dirty && !(fFlags & B_NOT_RESIZABLE)) {
 		BRect realResizeRect;
-		switch (fLook) {
+		switch ((int)fLook) {
 			case B_DOCUMENT_WINDOW_LOOK:
 				realResizeRect = fResizeRect;
 				// Resize rect at old location
Index: ../src/kits/tracker/FSUtils.h
===================================================================
--- ../src/kits/tracker/FSUtils.h	(revision 40842)
+++ ../src/kits/tracker/FSUtils.h	(working copy)
@@ -259,18 +259,6 @@
 _IMPEXP_TRACKER status_t FSLaunchUsing(const entry_ref *ref, BMessage *listOfRefs);
 
 
-// some extra directory_which values
-// move these to FindDirectory.h
-const uint32 B_USER_MAIL_DIRECTORY = 3500;
-const uint32 B_USER_QUERIES_DIRECTORY = 3501;
-const uint32 B_USER_PEOPLE_DIRECTORY = 3502;
-const uint32 B_USER_DOWNLOADS_DIRECTORY = 3503;
-const uint32 B_USER_DESKBAR_APPS_DIRECTORY = 3504;
-const uint32 B_USER_DESKBAR_PREFERENCES_DIRECTORY = 3505;
-const uint32 B_USER_DESKBAR_DEVELOP_DIRECTORY = 3506;
-const uint32 B_BOOT_DISK = 3507;
-	// map /boot into the directory_which enum for convenience
-
 class WellKnowEntryList {
 	// matches up names, id's and node_refs of well known entries in the
 	// system hierarchy
Index: ../headers/os/storage/FindDirectory.h
===================================================================
--- ../headers/os/storage/FindDirectory.h	(revision 40842)
+++ ../headers/os/storage/FindDirectory.h	(working copy)
@@ -69,11 +69,20 @@
 	B_USER_SOUNDS_DIRECTORY,
 	B_USER_DATA_DIRECTORY,
 	B_USER_CACHE_DIRECTORY,
+	B_USER_MAIL_DIRECTORY,
+	B_USER_QUERIES_DIRECTORY,
+	B_USER_PEOPLE_DIRECTORY,
+	B_USER_DOWNLOADS_DIRECTORY,
+	B_USER_DESKBAR_APPS_DIRECTORY,
+	B_USER_DESKBAR_PREFERENCES_DIRECTORY,
+	B_USER_DESKBAR_DEVELOP_DIRECTORY,
+	
 
 	/* Global directories. */
 	B_APPS_DIRECTORY					= 4000,
 	B_PREFERENCES_DIRECTORY,
 	B_UTILITIES_DIRECTORY,
+	B_BOOT_DISK,
 
 	/* Obsolete: Legacy BeOS definition to be phased out */
 	B_BEOS_DIRECTORY					= 1000,