Index: docs/userguide/sv_SE/applications/icon-o-matic.html
===================================================================
--- docs/userguide/sv_SE/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/sv_SE/applications/icon-o-matic.html	(working copy)
@@ -310,7 +310,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Tips &amp; Tricks</a></h3>
 <p>A few things you should keep in mind when working with Icon-O-Matic and some general tips for its usage:</p>
 <ul>
-<li><p>Read the <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
+<li><p>Read the <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
 <li><p>You should always try to minimize your use of paths, those are the most expensive, file size wise. Re-use paths wherever possible and work with manipulated shapes and their transformers instead. Smart use of gradients can also save space.</p></li>
 <li><p>Wherever possible, you should activate Snap-to-Grid from the <span class="menu">Options</span> menu when editing paths. Path points that align with the 64x64 pixel grid use less storage space. You'll also get the crispest look if points are set on exact pixel borders. For example, it is important to align the most prominent outlines with the 16x16 grid.</p></li>
 <li><p>Check the preview to see if your icon still looks good in 16x16. You may want to use the <a href="#i-o-m-shape-lod">Level Of Detail</a> settings described in the Shapes section.</p></li>
Index: docs/userguide/uk/applications/icon-o-matic.html
===================================================================
--- docs/userguide/uk/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/uk/applications/icon-o-matic.html	(working copy)
@@ -312,7 +312,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Tips &amp; Tricks</a></h3>
 <p>A few things you should keep in mind when working with Icon-O-Matic and some general tips for its usage:</p>
 <ul>
-<li><p>Read the <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
+<li><p>Read the <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
 <li><p>You should always try to minimize your use of paths, those are the most expensive, file size wise. Re-use paths wherever possible and work with manipulated shapes and their transformers instead. Smart use of gradients can also save space.</p></li>
 <li><p>Wherever possible, you should activate Snap-to-Grid from the <span class="menu">Options</span> menu when editing paths. Path points that align with the 64x64 pixel grid use less storage space. You'll also get the crispest look if points are set on exact pixel borders. For example, it is important to align the most prominent outlines with the 16x16 grid.</p></li>
 <li><p>Check the preview to see if your icon still looks good in 16x16. You may want to use the <a href="#i-o-m-shape-lod">Level Of Detail</a> settings described in the Shapes section.</p></li>
Index: docs/userguide/zh_CN/applications/icon-o-matic.html
===================================================================
--- docs/userguide/zh_CN/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/zh_CN/applications/icon-o-matic.html	(working copy)
@@ -314,7 +314,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">提示与技巧</a></h3>
 <p>A few things you should keep in mind when working with Icon-O-Matic and some general tips for its usage:</p>
 <ul>
-<li><p>Read the <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
+<li><p>Read the <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
 <li><p>You should always try to minimize your use of paths, those are the most expensive, file size wise. Re-use paths wherever possible and work with manipulated shapes and their transformers instead. Smart use of gradients can also save space.</p></li>
 <li><p>Wherever possible, you should activate Snap-to-Grid from the <span class="menu">Options</span> menu when editing paths. Path points that align with the 64x64 pixel grid use less storage space. You'll also get the crispest look if points are set on exact pixel borders. For example, it is important to align the most prominent outlines with the 16x16 grid.</p></li>
 <li><p>Check the preview to see if your icon still looks good in 16x16. You may want to use the <a href="#i-o-m-shape-lod">Level Of Detail</a> settings described in the Shapes section.</p></li>
Index: docs/userguide/en/applications/icon-o-matic.html
===================================================================
--- docs/userguide/en/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/en/applications/icon-o-matic.html	(working copy)
@@ -309,7 +309,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Tips &amp; Tricks</a></h3>
 <p>A few things you should keep in mind when working with Icon-O-Matic and some general tips for its usage:</p>
 <ul>
-<li><p>Read the <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
+<li><p>Read the <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
 <li><p>You should always try to minimize your use of paths, those are the most expensive, file size wise. Re-use paths wherever possible and work with manipulated shapes and their transformers instead. Smart use of gradients can also save space.</p></li>
 <li><p>Wherever possible, you should activate Snap-to-Grid from the <span class="menu">Options</span> menu when editing paths. Path points that align with the 64x64 pixel grid use less storage space. You'll also get the crispest look if points are set on exact pixel borders. For example, it is important to align the most prominent outlines with the 16x16 grid.</p></li>
 <li><p>Check the preview to see if your icon still looks good in 16x16. You may want to use the <a href="#i-o-m-shape-lod">Level Of Detail</a> settings described in the Shapes section.</p></li>
Index: docs/userguide/ru/applications/icon-o-matic.html
===================================================================
--- docs/userguide/ru/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/ru/applications/icon-o-matic.html	(working copy)
@@ -312,7 +312,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Полезные советы</a></h3>
 <p>Есть несколько вещей, которые вы должны помнить при работе с Icon-O-Matic и несколько советов, относящихся к ним:</p>
 <ul>
-<li><p>Прочтите статью <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Icon Guidelines</a>, чтобы изучить важные концепции иконок Haiku, такие как перспектива, цвета и тени.</p></li>
+<li><p>Прочтите статью <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Icon Guidelines</a>, чтобы изучить важные концепции иконок Haiku, такие как перспектива, цвета и тени.</p></li>
 <li><p>Всегда старайтесь минимизировать использование контуров - они наиболее накладны в отношении объема данных. Многократно используйте одни и те же контуры - где это только возможно, а так же манипулируйте формами, а не трансформаторами. Мудрое применение градиентов так же поможет сохранить объем.</p></li>
 <li><p>Где это возможно, включите режим привязки к сетке из меню <span class="menu">Опции (Options)</span>, когда редактируете контуры. Точки контуров, выровненные по 64x64 сетке требует меньше пространства. Для получения наиболее четкого изображения, установите точки по границам пикселей. Например, важно выровнять наиболее выраженные элементы по сетке 16x16.</p></li>
 <li><p>Проверяйте по предварительному просмотру, выглядит ли ваша иконка хорошо в размере 16x16. Возможно, вам понадобиться использовать <a href="#i-o-m-shape-lod">Уровень детализации (Level Of Detail)</a>, описанный в разделе, посвященном формам.</p></li>
Index: docs/userguide/pt_PT/applications/icon-o-matic.html
===================================================================
--- docs/userguide/pt_PT/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/pt_PT/applications/icon-o-matic.html	(working copy)
@@ -310,7 +310,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Tips &amp; Tricks</a></h3>
 <p>A few things you should keep in mind when working with Icon-O-Matic and some general tips for its usage:</p>
 <ul>
-<li><p>Read the <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
+<li><p>Read the <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
 <li><p>You should always try to minimize your use of paths, those are the most expensive, file size wise. Re-use paths wherever possible and work with manipulated shapes and their transformers instead. Smart use of gradients can also save space.</p></li>
 <li><p>Wherever possible, you should activate Snap-to-Grid from the <span class="menu">Options</span> menu when editing paths. Path points that align with the 64x64 pixel grid use less storage space. You'll also get the crispest look if points are set on exact pixel borders. For example, it is important to align the most prominent outlines with the 16x16 grid.</p></li>
 <li><p>Check the preview to see if your icon still looks good in 16x16. You may want to use the <a href="#i-o-m-shape-lod">Level Of Detail</a> settings described in the Shapes section.</p></li>
Index: docs/userguide/es/applications/icon-o-matic.html
===================================================================
--- docs/userguide/es/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/es/applications/icon-o-matic.html	(working copy)
@@ -313,7 +313,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Consejos y trucos</a></h3>
 <p>Se deben tomar en cuenta unas cuantas cosas cuando se trabaja con Icon-O-Matic y algunos consejos generales para su uso:</p>
 <ul>
-<li><p>Lea la <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Guías de iconos</a> para saber acerca de características importantes de iconos de Haiku, p. ej., perspectiva, colores y sombras.</p></li>
+<li><p>Lea la <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Guías de iconos</a> para saber acerca de características importantes de iconos de Haiku, p. ej., perspectiva, colores y sombras.</p></li>
 <li><p>Se debería intentar siempre minimizar el uso de rutas, pues son más pesadas en tamaño de archivo. Reutilice rutas siempre que sea posible y trabaje con figuras manipuladas y sus transformadores en su lugar. El buen uso de gradientes también puede ahorrar espacio.</p></li>
 <li><p>Cuando sea posible, se debería activar Snap-to-Grid (alinear a la gradilla) del menú <span class="menu">Options</span> (opciones) cuando se editen rutas. Los puntos de ruta que se alinean con la gradilla de 64x64 pixeles usan menos espacio de almacenamiento. También se obtiene la vista más limpia si se seleccionan en bordes de pixel exactos. Por ejemplo, es importante alinear las líneas más prominentes con la gradilla de 16x16.</p></li>
 <li><p>Verifique la previsualización para ver si su icono se ve bien incluso en 16x16. También sería bueno ver la configuración de <a href="#i-o-m-shape-lod">Nivel de detalle</a> descrito en la sección Figuras.</p></li>
Index: docs/userguide/fr/applications/icon-o-matic.html
===================================================================
--- docs/userguide/fr/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/fr/applications/icon-o-matic.html	(working copy)
@@ -311,7 +311,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Trucs et astuces</a></h3>
 <p>Voici quelques conseils que vous devriez avoir en tête lorsque vous travaillez avec Icon-O-Matic :</p>
 <ul>
-<li><p>Lisez les <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">règles d’icônes [en]</a> pour connaître les principales caractéristiques des icônes de Haiku, comme leur perspective, couleurs, et ombres.</p></li>
+<li><p>Lisez les <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">règles d’icônes [en]</a> pour connaître les principales caractéristiques des icônes de Haiku, comme leur perspective, couleurs, et ombres.</p></li>
 <li><p>Essayez de minimiser l’utilisation des chemins, ce sont les éléments les plus coûteux en terme de taille de fichier. Réutilisez-les chaque fois que possible et travaillez avec des formes modifiées et/ou transformées. L’utilisation astucieuse des dégradés peut également permettre de conserver de l’espace.</p></li>
 <li><p>Chaque fois que possible, vous devriez activer le réglage <i>Snap-to-Grid</i> (aligner sur la grille) du menu <span class="menu">Options</span> lorsque vous travaillez sur des chemins. Les points d’un chemin alignés sur la grille de 64x64 pixels utilisent moins d’espace de stockage. Vous obtiendrez aussi un meilleur rendu si ces points sont alignés sur des bordures de pixels. Par exemple, les bordures les plus importantes de votre icône devraient être alignées avec la grille 16x16.</p></li>
 <li><p>Vérifiez la prévisualisation pour vous assurez que votre icône est correctement rendue en taille 16x16. Vous aurez peut-être besoin d’utiliser le réglage de <a href="#i-o-m-shape-lod">niveau de détail</a> décrit dans la partie sur les formes.</p></li>
Index: docs/userguide/de/applications/icon-o-matic.html
===================================================================
--- docs/userguide/de/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/de/applications/icon-o-matic.html	(working copy)
@@ -313,7 +313,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Tipps &amp; Tricks</a></h3>
 <p>Ein paar Dinge, die man beherzigen sollte, wenn man Icon-O-Matic verwendet:</p>
 <ul>
-<li><p>Die <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Icon Guidelines</a> (englisch) enthalten wichtige Informationen zu Haiku Icons wie Perspektive, Farben und Schattenwurf.</p></li>
+<li><p>Die <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Icon Guidelines</a> (englisch) enthalten wichtige Informationen zu Haiku Icons wie Perspektive, Farben und Schattenwurf.</p></li>
 <li><p>Mit Pfaden sollte sparsam umgegangen werden, da sie am meisten Speicherplatz benötigen. Man sollte eher Formen bearbeiten und transformieren, um bereits bestehende Pfade wiederverwenden zu können. Ebenso kann die Verwendung von Gradienten Speicherplatz sparen.</p></li>
 <li><p>So oft es möglich ist, sollte die Option "Am Gitter ausrichten" aus den <span class="menu">Options</span> aktiviert werden. Pfade, deren Punkte sich am 64x64 Pixel-Gitter der Zeichenfläche orientieren, benötigen weniger Speicherplatz. Darüber hinaus wirken die Icons auch schärfer. Wichtige Konturen sollten am besten am 16x16 Raster ausgerichtet werden.</p></li>
 <li><p>Im Programmfenster ist oben links eine Vorschau des Icons in verschiedenen Auflösungen. Hier kann der sinnvolle Einsatz des <a href="#i-o-m-shape-lod">Detail-Grads</a> von Formen direkt überprüft werden.</p></li>
Index: docs/userguide/jp/applications/icon-o-matic.html
===================================================================
--- docs/userguide/jp/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/jp/applications/icon-o-matic.html	(working copy)
@@ -310,7 +310,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Tips &amp; Tricks</a></h3>
 <p>A few things you should keep in mind when working with Icon-O-Matic and some general tips for its usage:</p>
 <ul>
-<li><p>Read the <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
+<li><p>Read the <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
 <li><p>You should always try to minimize your use of paths, those are the most expensive, file size wise. Re-use paths wherever possible and work with manipulated shapes and their transformers instead. Smart use of gradients can also save space.</p></li>
 <li><p>Wherever possible, you should activate Snap-to-Grid from the <span class="menu">Options</span> menu when editing paths. Path points that align with the 64x64 pixel grid use less storage space. You'll also get the crispest look if points are set on exact pixel borders. For example, it is important to align the most prominent outlines with the 16x16 grid.</p></li>
 <li><p>Check the preview to see if your icon still looks good in 16x16. You may want to use the <a href="#i-o-m-shape-lod">Level Of Detail</a> settings described in the Shapes section.</p></li>
Index: docs/userguide/it/applications/icon-o-matic.html
===================================================================
--- docs/userguide/it/applications/icon-o-matic.html	(revision 39728)
+++ docs/userguide/it/applications/icon-o-matic.html	(working copy)
@@ -310,7 +310,7 @@
 <a id="i-o-m-tips" name="i-o-m-tips">Tips &amp; Tricks</a></h3>
 <p>A few things you should keep in mind when working with Icon-O-Matic and some general tips for its usage:</p>
 <ul>
-<li><p>Read the <a href="http://factory.haiku-os.org/documentation/icon_guidelines/">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
+<li><p>Read the <a href="http://svn.haiku-os.org/haiku/haiku/trunk/docs/icon_guidelines/index.html">Icon Guidelines</a> to learn about important characteristics of Haiku icons, e.g. perspective, colors and shadows.</p></li>
 <li><p>You should always try to minimize your use of paths, those are the most expensive, file size wise. Re-use paths wherever possible and work with manipulated shapes and their transformers instead. Smart use of gradients can also save space.</p></li>
 <li><p>Wherever possible, you should activate Snap-to-Grid from the <span class="menu">Options</span> menu when editing paths. Path points that align with the 64x64 pixel grid use less storage space. You'll also get the crispest look if points are set on exact pixel borders. For example, it is important to align the most prominent outlines with the 16x16 grid.</p></li>
 <li><p>Check the preview to see if your icon still looks good in 16x16. You may want to use the <a href="#i-o-m-shape-lod">Level Of Detail</a> settings described in the Shapes section.</p></li>